/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_PROXY_BASE_HPP_
#define V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_PROXY_BASE_HPP_

#include <v1/commonapi/telux/cv2x/Cv2xRadioManager.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypesProxyBase.hpp>


#include <v1/commonapi/telux/common/CommonDefines.hpp>
#include <v1/commonapi/telux/cv2x/Cv2xRadioTypes.hpp>

#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <cstdint>
#include <vector>

#include <CommonAPI/Event.hpp>
#include <CommonAPI/Proxy.hpp>
#include <functional>
#include <future>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v1 {
namespace commonapi {
namespace telux {
namespace cv2x {

class Cv2xRadioManagerProxyBase
    : virtual public ::v1::commonapi::telux::cv2x::Cv2xRadioTypesProxyBase {
public:
    typedef CommonAPI::Event<
        ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus
    > CurrentCv2xStatusEvent;

    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::common::CommonDefines::ServiceStatus&)> GetServiceStatusAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::common::CommonDefines::Status&)> StartCv2xAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::common::CommonDefines::Status&)> StopCv2xAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus&)> RequestCv2xStatusAsyncCallback;
    typedef std::function<void(const CommonAPI::CallStatus&, const ::v1::commonapi::telux::common::CommonDefines::ErrorCode&, const ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx&)> RequestCv2xStatusExAsyncCallback;

    virtual void GetServiceStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::ServiceStatus &_status, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> GetServiceStatusAsync(GetServiceStatusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual CurrentCv2xStatusEvent& getCurrentCv2xStatusEvent() = 0;
    virtual void startCv2x(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::Status &_status, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> startCv2xAsync(StartCv2xAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void stopCv2x(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::common::CommonDefines::Status &_status, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> stopCv2xAsync(StopCv2xAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void requestCv2xStatus(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatus &_status, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> requestCv2xStatusAsync(RequestCv2xStatusAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual void requestCv2xStatusEx(CommonAPI::CallStatus &_internalCallStatus, ::v1::commonapi::telux::common::CommonDefines::ErrorCode &_error, ::v1::commonapi::telux::cv2x::Cv2xRadioTypes::Cv2xStatusEx &_statusEx, const CommonAPI::CallInfo *_info = nullptr) = 0;
    virtual std::future<CommonAPI::CallStatus> requestCv2xStatusExAsync(RequestCv2xStatusExAsyncCallback _callback = nullptr, const CommonAPI::CallInfo *_info = nullptr) = 0;

    virtual std::future<void> getCompletionFuture() = 0;
};

} // namespace cv2x
} // namespace telux
} // namespace commonapi
} // namespace v1


// Compatibility
namespace v1_0 = v1;

#endif // V1_COMMONAPI_TELUX_CV2X_Cv2x_Radio_Manager_PROXY_BASE_HPP_
